routes/web.php
<?php

use App\Models;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| This file is where you may define all of the routes that are handled
| by your application. Just tell Laravel the URIs it should respond
| to using a Closure or controller method. Build something great!
|
*/

function MakeCrudRoutes($modulo, $config = [])
{
	$prefixo = $config['prefixo'] ?? '';
	$prefixo .= $config['alias'] ?? $modulo;
	$controller = ucfirst($modulo) . "Controller";

	Route::get("$prefixo/", "$controller@" . ($config['consultar'] ?? "consultar"))->name("$modulo.consultar");
	Route::get("$prefixo/novo", "$controller@" . ($config['novo'] ?? "novo"))->name("$modulo.novo");
	Route::get("$prefixo/{" . $modulo . "}",
		"$controller@" . ($config['visualizar'] ?? "visualizar"))->name("$modulo.visualizar");
	Route::get("$prefixo/{" . $modulo . "}/editar",
		"$controller@" . ($config['editar'] ?? "editar"))->name("$modulo.editar");
	Route::put("$prefixo/{" . $modulo . "}",
		"$controller@" . ($config['atualizar'] ?? "atualizar"))->name("$modulo.atualizar");
	Route::post("$prefixo/", "$controller@" . ($config['cadastrar'] ?? "cadastrar"))->name("$modulo.cadastrar");
	Route::delete("$prefixo/{" . $modulo . "}",
		"$controller@" . ($config['apagar'] ?? "apagar"))->name("$modulo.apagar");
}

Route::group(['middleware' => ['auth']], function () {
	// MakeCrudRoutes(['modulo' => 'vendedor']);
	MakeCrudRoutes('usuario', ['visualizar' => 'editar']);
	MakeCrudRoutes('atleta', ['visualizar' => 'editar']);
	MakeCrudRoutes('pessoa', ['visualizar' => 'editar']);
	MakeCrudRoutes('clube', ['visualizar' => 'editar']);
	MakeCrudRoutes('usuario', ['visualizar' => 'editar']);
	MakeCrudRoutes('empresa', ['visualizar' => 'editar']);
	MakeCrudRoutes('lancamento', ['visualizar' => 'editar']);
	MakeCrudRoutes('conta', ['visualizar' => 'editar']);
	MakeCrudRoutes('planoConta', ['visualizar' => 'editar']);
	MakeCrudRoutes('formaPagamento', ['visualizar' => 'editar']);
	MakeCrudRoutes('evento', ['visualizar' => 'editar']);
	MakeCrudRoutes('modalidade', ['visualizar' => 'editar']);
});

Route::get('pessoa/{pessoa}/carregar/{prefixo}', 'PessoaController@carregarFormulario');
Route::get('recibo/visualizar/{recibo}', 'ReciboController@visualizar')->name('recibo.visualizar');
Route::put('recibo/gerar/{recibo}', 'ReciboController@gerar')->name('recibo.gerar');
Route::put('recibo/cancelar/{recibo}', 'ReciboController@cancelar')->name('recibo.cancelar');
Route::get('verificar', 'VerificarReciboController@verificar')->name('recibo.verificar');
Route::post('verificar', 'VerificarReciboController@validar')->name('recibo.validar');

Route::get('figlicense', 'LancamentoController@figLicensePartial');
Route::get('transferencia', 'LancamentoController@transferencia');

Route::get('teste', function() {
	Excel::create('Filename', function($excel) {

	    $excel->sheet('Diário', function($sheet) {
	    	$lancamentos = Models\Lancamento::all();
        	$row = 4;
	    	$sheet->row($row++,
	            array('Data Mov.', 'Nº Doc', 'HISTÓRICO', 'VALOR', 'D/C', 'SALDO', 'REFERENTE', 'Código de Evento', 'Nº Nota')
	        );
	        foreach ($lancamentos ?? [] as $lancamento) {
		    	$sheet->row($row++, array(
			    		!empty($lancamento->pagamenta->data) ? $lancamento->pagamento->data->format('m/Y') : '',
			    		$lancamento->codigo,
			    		$lancamento->historico,
			    		$lancamento->valor,
			    		$lancamento->credito ? 'C' : 'D',
			    		$lancamento->saldo ?? 0,
			    		'',
			    		$lancamento->pagamento->planoContas->codigo ?? null,
			    		$lancamento->notaFiscal->codigo
			    	)
		    	);
	        }
	    });
	})->export('xls');
});

include 'web/misc.php';
include 'web/auth.php';
include 'web/dashboard.php';

app/Models/Clube.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;

class Clube extends Pessoa
{

	protected static function boot() {
        parent::boot();

        static::addGlobalScope('pessoa', function (Builder $builder) {
			$builder->join('pessoas as pessoa_join', 'pessoa_join.id', 'clubes.pessoa_id')->selectRaw('pessoa_join.*, clubes.*')->whereNull('pessoa_join.deleted_at');
        });
    }

	public function pessoa()
	{
		return $this->belongsTo('App\Models\Pessoa');
	}
}

app/Models/Pessoa.php
<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\SoftDeletes;

class Pessoa extends AbstractModel
{
    use SoftDeletes;

    public static $tipo = [1 => 'Física', 2 => 'Jurídica'];

    public $fotoPadraoPessoaFisica = 'user-no-photo.jpg';
    public $fotoPadraoPessoaJuridica = 'no-image.png';

    public $dates = [
        'data_nascimento',
        'rg_data_expedicao',
        'passaporte_data_validade',
    ];

    public function setDataNascimentoAttribute($value)
    {
        $this->attributes['data_nascimento'] = !empty($value) ? Carbon::createFromFormat('d/m/Y', $value)->format('Y-m-d')." 00:00:00" : $value;
    }

    public function setRgDataExpedicaoAttribute($value)
    {
        $this->attributes['rg_data_expedicao'] = !empty($value) ? Carbon::createFromFormat('d/m/Y', $value)->format('Y-m-d')." 00:00:00" : $value;
    }

    public function setPassaporteDataValidadeAttribute($value)
    {
        $this->attributes['passaporte_data_validade'] = !empty($value) ? Carbon::createFromFormat('d/m/Y', $value)->format('Y-m-d')." 00:00:00" : $value;
    }

    // Validação
    public static function validationRules()
    {
        $tipoPessoas = collect(self::$tipo);

        return [
            'nome' => 'required|max:255',
            'tipo' => 'nullable|in:' . $tipoPessoas->keys()->implode(','),
            'cpf' => 'nullable|cpf',
            'razao_social' => 'nullable|max:255',
            'cnpj' => 'nullable|cnpj',
            'rg' => 'nullable|max:20',
            'rg_orgao_expedidor' => 'nullable|max:50',
        ];
    }

    // Regras
    public function isFisica()
    {
        return $this->tipo == collect(self::$tipo)->search('Física');
    }

    public function isJuridica()
    {
        return $this->tipo == collect(self::$tipo)->search('Jurídica');
    }

    // Atributos calculados
    public function getNomeESobrenomeAttribute()
    {
        return $this->getPrimeiroNomeAttribute() . " " . $this->getSegundoNomeAttribute();
    }

    public function getPrimeiroNomeAttribute()
    {
        $nomeArr = explode(' ', $this->nome);
        $nome = ($nomeArr[0] ?? '');

        return ucwords(trim($nome));
    }

    public function getSegundoNomeAttribute()
    {
        $nomeArr = explode(' ', $this->nome);
        $nome = ($nomeArr[1] ?? '');

        return ucwords(trim($nome));
    }

    public function getFotoAttribute()
    {
        $fotoPadrao = $this->tipo == collect(self::$tipo)->search('Física') ? $this->fotoPadraoPessoaFisica : $this->fotoPadraoPessoaJuridica;

        return 'images/' . ($this->photo ?? $fotoPadrao);
    }

    public function scopeAvulsas($query)
    {
        return $query->doesntHave('atleta')->doesntHave('clube')->doesntHave('usuario');
    }

    // public function getenderecoAttribute() {
    //     $endereco = $this->enderecos()->get()->first();/*->principal()->first();*/

    //     if ($endereco == null) {
    //         $endereco  = new Endereco;
    //         $endereco->pessoa()->associate($this);
    //     }

    //     return $endereco;
    // }

    // Relações
    public function atleta()
    {
        return $this->hasOne('App\Models\Atleta');
    }

    public function clube()
    {
        return $this->hasOne('App\Models\Clube');
    }

    public function endereco()
    {
        return $this->belongsTo('App\Models\Endereco', 'endereco_principal_id');
    }

    public function contato()
    {
        return $this->belongsTo('App\Models\Contato', 'contato_principal_id');
    }

    public function dadosBancarios()
    {
        return $this->belongsTo('App\Models\DadosBancarios', 'dado_bancario_id');
    }

    public function usuario()
    {
        return $this->hasOne('App\Models\Usuario');
    }

}

app/Http/Controllers/ClubeController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests;
use App\Models;

class ClubeController extends Controller
{

    public function consultar()
    {
        $clubes = Models\Clube::get();

        return view('clubes.consultar', compact('clubes'));
    }

    public function novo()
    {
        $estados = Models\Estado::all();
        $pessoaTipos = collect(Models\Pessoa::$tipo);

        return view('clubes.novo', compact('estados', 'pessoaTipos'));
    }

    public function visualizar(Models\Clube $clube)
    {
        return view('clubes.visualizar', compact('clube'));
    }

    public function editar(Models\Clube $clube)
    {
        $estados = Models\Estado::all();
        $pessoaTipos = collect(Models\Pessoa::$tipo);

        return view('clubes.editar', compact('clube', 'estados', 'pessoaTipos'));
    }

    public function cadastrar(Requests\FormularioClube $request)
    {
        $mensagens = [];

        \DB::beginTransaction();
        try {
            $pessoa = new Models\Pessoa($request->input('formulario.pessoa'));

            $endereco = Models\Endereco::create($request->input('formulario.endereco'));
            $pessoa->endereco()->associate($endereco);

            $contato = Models\Contato::create($request->input('formulario.contato'));
            $contato->nome = $pessoa->nome;
            $contato->save();

            $pessoa->contato()->associate($contato);

            $dadosBancarios = Models\DadosBancarios::create($request->input('formulario.dadosBancarios'));
            $dadosBancarios->save();
            $pessoa->dadosBancarios()->associate($dadosBancarios);
            $pessoa->save();

            $clube = new Models\Clube;
            $clube->pessoa()->associate($pessoa);
            $clube->save();

            $mensagens['success'] = ucfirst(__('clube')) . ' cadastrado com sucesso!';
        } catch (Exception $e) {
            \DB::rollBack();
            $mensagens['error'] = 'Falha ao cadastrar ' . __('clube');
            throw $e;
        }

        \DB::commit();

        return redirect()->route('clube.visualizar', ['id' => $clube->id])
            ->with('notifications', $mensagens);
    }

    public function atualizar(Requests\FormularioClube $request, Models\Clube $clube)
    {
        $mensagens = [];

        \DB::beginTransaction();
        try {
            $pessoa = $clube->pessoa;
            $pessoa->fill($request->input('formulario.pessoa'));

            $endereco = Models\Endereco::find($request->input('formulario.endereco.id')) ?? new Models\Endereco;
            $endereco->fill($request->input('formulario.endereco'));
            $endereco->save();
            $pessoa->endereco()->associate($endereco);

            $contato = Models\Contato::find($request->input('formulario.contato.id')) ?? new Models\Contato;
            $contato->nome = $pessoa->nome;
            $contato->fill($request->input('formulario.contato'));
            $contato->save();
            $pessoa->contato()->associate($contato);

            $dadosBancarios = Models\DadosBancarios::find($request->input('formulario.dadosBancarios.id')) ?? new Models\DadosBancarios;
            $dadosBancarios->fill($request->input('formulario.dadosBancarios'));
            $dadosBancarios->save();
            $pessoa->dadosBancarios()->associate($dadosBancarios);

            $pessoa->save();

            $clube->save();
            $mensagens['success'] = ucfirst(__('clube')) . ' atualizado com sucesso!';
        } catch (Exception $e) {
            \DB::rollBack();
            $mensagens['error'] = 'Falha ao atualizar ' . __('clube');
            throw $e;
        }

        \DB::commit();

        return redirect()->route('clube.editar', ['id' => $clube->id])
            ->with('notifications', $mensagens);
    }

    public function apagar(Models\Clube $clube)
    {
        $mensagens = [];
        try {
            $clube->delete();
            $mensagens['success'] = ucfirst(__('clube')) . ' apagado com sucesso!';
        } catch (Exception $e) {
            $mensagens['error'] = 'Falha ao apagar ' . __('clube');
        }

        return redirect()->route('clube.consultar')
            ->with('notifications', $mensagens);
    }

}

resources/views/clubes/partials/dadosAdicionais.blade.php
@define($prefixoInput = !empty($prefixo) ? $prefixo  : '')
@define($prefixo = !empty($prefixo) ? $prefixo.'.'  : '')

<div class="contato_container">
	<div class="row">
		<div class="form-group col-md-3{{ $errors->has($prefixo.'categoria') ? ' has-error' : '' }}">
			<label class="control-label">Categoria / Classificação</label>
			<input type="text" class="form-control" name="{{ $prefixoInput }}[categoria]" value="{{ old($prefixo.'categoria') ?? $clube->categoria ?? '' }}">
			@showError($prefixo.'categoria')
		</div>

		<div class="form-group col-md-3{{ $errors->has($prefixo.'comissionamento') ? ' has-error' : '' }}">
			<label class="control-label">Vendedor</label>
			<input i type="text" class="form-control" name="{{ $prefixoInput }}[comissionamento]" value="{{ old($prefixo.'comissionamento') ?? $clube->comissionamento ?? '' }}">
			@showError($prefixo.'comissionamento')
		</div>
		<div class="form-group col-md-3{{ $errors->has($prefixo.'comissionamento') ? ' has-error' : '' }}">
			<label class="control-label">Início da atividade</label>
			<input i type="text" class="form-control" name="{{ $prefixoInput }}[comissionamento]" value="{{ old($prefixo.'comissionamento') ?? $clube->comissionamento ?? '' }}">
			@showError($prefixo.'comissionamento')
		</div>
		<div class="form-group col-md-3{{ $errors->has($prefixo.'comissionamento') ? ' has-error' : '' }}">
			<label class="control-label">Final da atividade</label>
			<input i type="text" class="form-control" name="{{ $prefixoInput }}[comissionamento]" value="{{ old($prefixo.'comissionamento') ?? $clube->comissionamento ?? '' }}">
			@showError($prefixo.'comissionamento')
		</div>
	</div>
	<div class="row">
		<div class="form-group col-md-12{{ $errors->has($prefixo.'observacoes') ? ' has-error' : '' }}">
			<label class="control-label">Observações</label>
			<textarea class="form-control" name="{{ $prefixoInput }}[observacoes]">{{ old($prefixo.'observacoes') ?? $clube->observacoes ?? '' }}</textarea>
			@showError($prefixo.'observacoes')
		</div>
	</div>
</div>

resources/views/clubes/partials/formulario.blade.php
@define($pessoa = $clube ?? null)
@define($pessoaOnly = $pessoaTipos->search('Jurídica'))
@include('pessoas.partials.formulario')

resources/views/clubes/partials/painelResumo.blade.php
<div class="row m-b-lg">
	<div class="col-lg-4 text-center">
		<h2>{{ $clube->pessoa->nomeESobrenome }}</h2>

		<div class="m-b-sm">
			<img alt="image" class="img-circle" src="{{ asset($clube->pessoa->foto) }}"
				 style="width: 62px">
		</div>
	</div>
	<div class="col-lg-8">
		<!-- <strong>
			Resumo
		</strong> -->

		<address class="m-t-md text-left">
			<i class="fa fa-map-marker"></i> <strong>{{ $clube->pessoa->endereco->cidadeEstado ?? 'Nenhum informado' }}</strong><br>
			<i class="fa fa-phone"></i> {{ $clube->pessoa->contato->endereco->telefone->numero ?? 'Nenhum informado' }}<br/>
			<i class="fa fa-envelope"></i> <span class="clube_email" style="word-break: break-all">{{ $clube->email ?? 'Nenhum informado'}}</span><br/>
		</address>
		<button type="button" class="btn btn-primary btn-sm btn-block"><i
				class="fa fa-envelope"></i> Send Message
		</button>
	</div>
</div>
<div class="client-detail">
	<div class="full-height-scroll">

		<strong>Last activity</strong>

		<ul class="list-group clear-list">
			<li class="list-group-item fist-item">
				<span class="pull-right"> 09:00 pm </span>
				Please contact me
			</li>
			<li class="list-group-item">
				<span class="pull-right"> 10:16 am </span>
				Sign a contract
			</li>
			<li class="list-group-item">
				<span class="pull-right"> 08:22 pm </span>
				Open new shop
			</li>
			<li class="list-group-item">
				<span class="pull-right"> 11:06 pm </span>
				Call back to Sylvia
			</li>
			<li class="list-group-item">
				<span class="pull-right"> 12:00 am </span>
				Write a letter to Sandra
			</li>
		</ul>
		<strong>Notes</strong>
		<p>
			Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
			tempor incididunt ut labore et dolore magna aliqua.
		</p>
		<hr/>
		<strong>Timeline activity</strong>
		<div id="vertical-timeline" class="vertical-container dark-timeline">
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon gray-bg">
					<i class="fa fa-coffee"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>Conference on the sales results for the previous year.
					</p>
					<span class="vertical-date small text-muted"> 2:10 pm - 12.06.2014 </span>
				</div>
			</div>
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon gray-bg">
					<i class="fa fa-briefcase"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>Many desktop publishing packages and web page editors now use Lorem.
					</p>
					<span class="vertical-date small text-muted"> 4:20 pm - 10.05.2014 </span>
				</div>
			</div>
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon gray-bg">
					<i class="fa fa-bolt"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>There are many variations of passages of Lorem Ipsum available.
					</p>
					<span class="vertical-date small text-muted"> 06:10 pm - 11.03.2014 </span>
				</div>
			</div>
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon navy-bg">
					<i class="fa fa-warning"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>The generated Lorem Ipsum is therefore.
					</p>
					<span class="vertical-date small text-muted"> 02:50 pm - 03.10.2014 </span>
				</div>
			</div>
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon gray-bg">
					<i class="fa fa-coffee"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>Conference on the sales results for the previous year.
					</p>
					<span class="vertical-date small text-muted"> 2:10 pm - 12.06.2014 </span>
				</div>
			</div>
			<div class="vertical-timeline-block">
				<div class="vertical-timeline-icon gray-bg">
					<i class="fa fa-briefcase"></i>
				</div>
				<div class="vertical-timeline-content">
					<p>Many desktop publishing packages and web page editors now use Lorem.
					</p>
					<span class="vertical-date small text-muted"> 4:20 pm - 10.05.2014 </span>
				</div>
			</div>
		</div>
	</div>
</div>

resources/views/clubes/partials/sem_registro.blade.php
<div class="text-center">
	<svg class="sem-registro"><use href="{{ asset('images/general.svg#people') }}"></use></svg>
	<h2 class="sem-registro text-primary">Nenhum <span class="">{{ __('modulos.clube') }}</span> cadastrado</h3>
{{-- 	<div class="row text-left">
		<div class="col-md-12">
			<h3 class="text-info">Recursos</h3>
				<p><i class="fa fa-check"></i> Cadastre os {{ __('modulos.clubes') }}</p>
				<p><i class="fa fa-check"></i> Gerencie os dados pessoais, de contato e bancários</p>
				<p><i class="fa fa-check"></i> Controle o método as pagamentos gerados para cada {{ __('modulos.clube') }}</p>
		</div>
	</div>
 --}}</div>

resources/views/clubes/partials/tabela.blade.php
<div class="row">
	<div class="col-md-12">
		<div class="input-group">
			<input type="text" placeholder="Pesquisar por nome ou cnpj " class="input form-control filtroClube">
			<span class="input-group-btn">
				<button type="button" class="btn btn btn-primary"> <i class="fa fa-search"></i></button>
			</span>
		</div>
	</div>
</div>
<br/>
<div class="row">
	<div class="col-sm-12">
		<div class="full-height-scroll">
			<div class="table-responsive">
				<table class="table table-striped table-bordered table-hover mt-0 tableClube">
					<thead>
						<tr>
							<th>Nome</th>
							<th>CNPJ</th>
							<th>Telefone</th>
							<th>Situação</th>
							<th class="dt-no-export">Ações</th>
						</tr>
					</thead>
					<tbody>
					@foreach($clubes as $clube)
						<tr class="pointer visualizarClube">
							<td><img class="gravatar" src="{{ asset($clube->pessoa->foto) }}"> {{ $clube->pessoa->nomeESobrenome }}</td>
							<td> {{ $clube->pessoa->cnpj }}</td>
							<td><i class="fa fa-phone"> </i> {{ $clube->pessoa->telefones ?? 'Não informado'}}</td>
							<td class="client-status"><span class="label label-primary">Ativo</span></td>
							<td class="text-center acoes" nowrap width="5%">
								<i class="fa fa-search fa-1-4x has-tooltip hidden" data-placement="bottom" title="Visualizar"></i>
								<a href="{{ route('clube.editar', ['id' => $clube->id]) }}"><i class="fa fa-edit fa-1-4x has-tooltip" data-placement="bottom" title="Editar"></i></a>
								<form method="POST" action="{{ route('clube.apagar', ['id' => $clube->id]) }}">
									@method('DELETE')
									<a role="submit"><i class="fa fa-1-4x fa-trash text-danger" data-placement="bottom" title="Apagar"></i></a>
								</form>
							</td>
						</tr>
					@endforeach
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>